Getting started with React Sankey Chart component

This section describes how to integrate the Syncfusion React Sankey Chart component into a new React application. You’ll learn about dependencies, installation steps, and how to create your first Sankey Chart visualization.

Prerequisites

Before getting started, ensure that your development environment meets the system requirements for Syncfusion® React UI components. That page documents the supported React, Node.js, and npm versions, and includes the React-version compatibility table for Syncfusion React components.

  • Basic knowledge of React and TypeScript (recommended)
  • A code editor like Visual Studio Code

Dependencies

Below is the list of minimum dependencies required to use the Sankey Chart component.

|-- @syncfusion/ej2-react-charts
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-data
    |-- @syncfusion/ej2-charts
    |-- @syncfusion/ej2-react-base
    |-- @syncfusion/ej2-pdf-export
    |-- @syncfusion/ej2-file-utils
    |-- @syncfusion/ej2-compression
    |-- @syncfusion/ej2-svg-base

Installation and Configuration

Setting Up the React Development Environment

To easily set up a React application, use the Vite CLI (npm create vite), which provides:

  • Faster development environment with instant hot module replacement (HMR)
  • Smaller bundle sizes
  • Optimized production builds
  • Better performance compared to traditional tools like create-react-app

For detailed steps, refer to the Vite installation instructions. Vite sets up your environment using JavaScript and optimizes your application for production.

Note: To create a React application using create-react-app instead, refer to this documentation for more details.

To create a new React application, run the following command.

npm create vite@latest my-app

This command will prompt you for a few settings for the new project, such as selecting a framework and a variant.

Initial_setup

Choose React from the framework list, then select either the TypeScript or JavaScript variant. The next two sections show the exact commands for each variant.

To set up a React application in TypeScript environment, run the following command.

npm create vite@latest my-app -- --template react-ts
cd my-app

To set up a React application in JavaScript environment, run the following command.

npm create vite@latest my-app -- --template react
cd my-app

After the project is created, start the development server with:

npm run dev

Install Syncfusion® Sankey Chart Package

All Essential® JS 2 packages are published on the npmjs.com public registry.

To install the Sankey Chart package, run the following command:

npm install @syncfusion/ej2-react-charts

The package is added to the dependencies section of the package.json file automatically. The --save flag is no longer required for npm 5 and later.

Add Sankey Chart to the project

Add the Sankey Chart component to your entry file (src/App.jsx or src/App.tsx):

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  SankeyComponent, Inject, SankeyTooltip, SankeyLegend,
  SankeyExport,
  SankeyNodeDirective,
  SankeyNodesCollectionDirective,
  SankeyLinkDirective,
  SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';

function App() {
  return (
    <div className="control-pane">
      <div className="control-section" id="sankey-container">
        <SankeyComponent
          width="90%"
          height="420px"
          title="Sankey Chart"
        >
          <SankeyNodesCollectionDirective>
            <SankeyNodeDirective id="A" />
            <SankeyNodeDirective id="B" />
            <SankeyNodeDirective id="C" />
          </SankeyNodesCollectionDirective>
          <SankeyLinksCollectionDirective>
            <SankeyLinkDirective sourceId="A" targetId="B" value={100} />
            <SankeyLinkDirective sourceId="B" targetId="C" value={80} />
          </SankeyLinksCollectionDirective>
          <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
        </SankeyComponent>
      </div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  SankeyComponent, Inject, SankeyTooltip, SankeyLegend,
  SankeyExport,
  SankeyNodeDirective,
  SankeyNodesCollectionDirective,
  SankeyLinkDirective,
  SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';

function App() {
  return (
    <div className="control-pane">
      <div className="control-section" id="sankey-container">
        <SankeyComponent
          width="90%"
          height="420px"
          title="Sankey Chart"
        >
          <SankeyNodesCollectionDirective>
            <SankeyNodeDirective id="A" />
            <SankeyNodeDirective id="B" />
            <SankeyNodeDirective id="C" />
          </SankeyNodesCollectionDirective>
          <SankeyLinksCollectionDirective>
            <SankeyLinkDirective sourceId="A" targetId="B" value={100} />
            <SankeyLinkDirective sourceId="B" targetId="C" value={80} />
          </SankeyLinksCollectionDirective>
          <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
        </SankeyComponent>
      </div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));

Add data to Sankey Chart

Now you can add data to the Sankey Chart control by defining nodes and links. Nodes represent the categories, and links represent the flow between them.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  SankeyComponent,
  Inject,
  SankeyTooltip,
  SankeyExport,
  SankeyNodeDirective,
  SankeyNodesCollectionDirective,
  SankeyLinkDirective,
  SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';

function App() {
  return (
    <div className="control-pane">
      <div className="control-section" id="sankey-container">
        <SankeyComponent
          width="90%"
          height="420px"
          title="Energy Flow Diagram"
        >
          <SankeyNodesCollectionDirective>
            <SankeyNodeDirective id="Energy Input" label={{ text: 'Energy Input' }} />
            <SankeyNodeDirective id="Generation" label={{ text: 'Generation' }} />
            <SankeyNodeDirective id="Distribution" label={{ text: 'Distribution' }} />
            <SankeyNodeDirective id="Consumption" label={{ text: 'Consumption' }} />
          </SankeyNodesCollectionDirective>
          <SankeyLinksCollectionDirective>
            <SankeyLinkDirective sourceId="Energy Input" targetId="Generation" value={500} />
            <SankeyLinkDirective sourceId="Generation" targetId="Distribution" value={450} />
            <SankeyLinkDirective sourceId="Distribution" targetId="Consumption" value={400} />
          </SankeyLinksCollectionDirective>
          <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
        </SankeyComponent>
      </div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  SankeyComponent, Inject, SankeyTooltip, SankeyLegend, SankeyExport,
  SankeyNodeDirective,
  SankeyNodesCollectionDirective,
  SankeyLinkDirective,
  SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';

function App() {
  return (
    <div className="control-pane">
      <div className="control-section" id="sankey-container">
        <SankeyComponent
          width="90%"
          height="420px"
          title="Energy Flow Diagram"
        >
          <SankeyNodesCollectionDirective>
            <SankeyNodeDirective id="Energy Input" label={{ text: 'Energy Input' }} />
            <SankeyNodeDirective id="Generation" label={{ text: 'Generation' }} />
            <SankeyNodeDirective id="Distribution" label={{ text: 'Distribution' }} />
            <SankeyNodeDirective id="Consumption" label={{ text: 'Consumption' }} />
          </SankeyNodesCollectionDirective>
          <SankeyLinksCollectionDirective>
            <SankeyLinkDirective sourceId="Energy Input" targetId="Generation" value={500} />
            <SankeyLinkDirective sourceId="Generation" targetId="Distribution" value={450} />
            <SankeyLinkDirective sourceId="Distribution" targetId="Consumption" value={400} />
          </SankeyLinksCollectionDirective>
          <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
        </SankeyComponent>
      </div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));

Module injection

Sankey Chart component provides support for tooltip and legend interactions. To enable these features, you need to inject the required modules into the component.

  • SankeyTooltip - Inject this module to enable tooltip feature.
  • SankeyLegend - Inject this module to enable legend feature.

These modules are tree-shakable; only the ones you inject are added to the bundle. Import the modules from the chart package and inject them into the component as follows.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  SankeyComponent, Inject, SankeyTooltip, SankeyLegend, SankeyExport,
  SankeyNodeDirective,
  SankeyNodesCollectionDirective,
  SankeyLinkDirective,
  SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';
import { Browser } from '@syncfusion/ej2-base';

function App() {
  const onLoaded = () => {
    const element = document.getElementById('sankey-container');
    if (element) element.setAttribute('title', '');
  };

  return (
    <div className="control-pane">
      <div className="control-section" id="sankey-container">
        <SankeyComponent
          width="90%"
          height={Browser.isDevice ? '600px' : '450px'}
          title="California Energy Consumption in 2023"
          subTitle="Source: Lawrence Livermore National Laboratory"
          linkStyle={{ opacity: 0.6, curvature: 0.55, colorType: 'Source' }}
          labelSettings={{ visible: Browser.isDevice ? false : true }}
          tooltip={{ enable: true }}
          legendSettings={{ visible: true, position: 'Bottom', itemPadding: 8 }}
          loaded={onLoaded}
        >
          <SankeyNodesCollectionDirective>
            <SankeyNodeDirective id="Electricity Generation" offset={-120} />
            <SankeyNodeDirective id="Residential" offset={38} />
            <SankeyNodeDirective id="Commercial" offset={36} />
            <SankeyNodeDirective id="Industrial" offset={34} />
            <SankeyNodeDirective id="Transportation" offset={32} />
            <SankeyNodeDirective id="Rejected Energy" offset={-40} />
            <SankeyNodeDirective id="Energy Services" />
            <SankeyNodeDirective id="Solar" />
            <SankeyNodeDirective id="Nuclear" />
            <SankeyNodeDirective id="Wind" />
            <SankeyNodeDirective id="Geothermal" />
            <SankeyNodeDirective id="Natural Gas" />
            <SankeyNodeDirective id="Coal" />
            <SankeyNodeDirective id="Biomass" />
            <SankeyNodeDirective id="Petroleum" offset={-10} />
          </SankeyNodesCollectionDirective>
          <SankeyLinksCollectionDirective>
            <SankeyLinkDirective sourceId="Solar" targetId="Electricity Generation" value={454} />
            <SankeyLinkDirective sourceId="Nuclear" targetId="Electricity Generation" value={185} />
            <SankeyLinkDirective sourceId="Wind" targetId="Electricity Generation" value={47.8} />
            <SankeyLinkDirective sourceId="Geothermal" targetId="Electricity Generation" value={40} />
            <SankeyLinkDirective sourceId="Natural Gas" targetId="Electricity Generation" value={800} />
            <SankeyLinkDirective sourceId="Coal" targetId="Electricity Generation" value={28.7} />
            <SankeyLinkDirective sourceId="Biomass" targetId="Electricity Generation" value={50} />
            <SankeyLinkDirective sourceId="Electricity Generation" targetId="Residential" value={182} />
            <SankeyLinkDirective sourceId="Natural Gas" targetId="Residential" value={400} />
            <SankeyLinkDirective sourceId="Petroleum" targetId="Residential" value={50} />
            <SankeyLinkDirective sourceId="Electricity Generation" targetId="Commercial" value={351} />
            <SankeyLinkDirective sourceId="Natural Gas" targetId="Commercial" value={300} />
            <SankeyLinkDirective sourceId="Electricity Generation" targetId="Industrial" value={641} />
            <SankeyLinkDirective sourceId="Natural Gas" targetId="Industrial" value={786} />
            <SankeyLinkDirective sourceId="Biomass" targetId="Industrial" value={563} />
            <SankeyLinkDirective sourceId="Petroleum" targetId="Industrial" value={300} />
            <SankeyLinkDirective sourceId="Electricity Generation" targetId="Transportation" value={20} />
            <SankeyLinkDirective sourceId="Natural Gas" targetId="Transportation" value={51} />
            <SankeyLinkDirective sourceId="Biomass" targetId="Transportation" value={71} />
            <SankeyLinkDirective sourceId="Petroleum" targetId="Transportation" value={2486} />
            <SankeyLinkDirective sourceId="Residential" targetId="Rejected Energy" value={432} />
            <SankeyLinkDirective sourceId="Commercial" targetId="Rejected Energy" value={351} />
            <SankeyLinkDirective sourceId="Industrial" targetId="Rejected Energy" value={972} />
            <SankeyLinkDirective sourceId="Transportation" targetId="Rejected Energy" value={1920} />
            <SankeyLinkDirective sourceId="Residential" targetId="Energy Services" value={200} />
            <SankeyLinkDirective sourceId="Commercial" targetId="Energy Services" value={300} />
            <SankeyLinkDirective sourceId="Industrial" targetId="Energy Services" value={755} />
            <SankeyLinkDirective sourceId="Transportation" targetId="Energy Services" value={637} />
          </SankeyLinksCollectionDirective>
          <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
        </SankeyComponent>
      </div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    SankeyComponent, Inject, SankeyTooltip, SankeyLegend, SankeyExport,
    SankeyNodeDirective,
    SankeyNodesCollectionDirective,
    SankeyLinkDirective,
    SankeyLinksCollectionDirective
} from '@syncfusion/ej2-react-charts';
import { Browser } from '@syncfusion/ej2-base';

function App() {
    const onLoaded = () => {
        const element = document.getElementById('sankey-container');
        if (element) element.setAttribute('title', '');
    };

    return (
        <div className="control-pane">
            <div className="control-section">
                <SankeyComponent
                    id="sankey-container"
                    width="90%"
                    height={Browser.isDevice ? '600px' : '450px'}
                    title="California Energy Consumption in 2023"
                    subTitle="Source: Lawrence Livermore National Laboratory"
                    linkStyle={{ opacity: 0.6, curvature: 0.55, colorType: 'Source' }}
                    labelSettings={{ visible: Browser.isDevice ? false : true }}
                    tooltip={{ enable: true }}
                    legendSettings={{ visible: true, position: 'Bottom', itemPadding: 8 }}
                    loaded={onLoaded}
                >
                    <SankeyNodesCollectionDirective>
                        <SankeyNodeDirective id="Electricity Generation" offset={-120} />
                        <SankeyNodeDirective id="Residential" offset={38} />
                        <SankeyNodeDirective id="Commercial" offset={36} />
                        <SankeyNodeDirective id="Industrial" offset={34} />
                        <SankeyNodeDirective id="Transportation" offset={32} />
                        <SankeyNodeDirective id="Rejected Energy" offset={-40} />
                        <SankeyNodeDirective id="Energy Services" />
                        <SankeyNodeDirective id="Solar" />
                        <SankeyNodeDirective id="Nuclear" />
                        <SankeyNodeDirective id="Wind" />
                        <SankeyNodeDirective id="Geothermal" />
                        <SankeyNodeDirective id="Natural Gas" />
                        <SankeyNodeDirective id="Coal" />
                        <SankeyNodeDirective id="Biomass" />
                        <SankeyNodeDirective id="Petroleum" offset={-10} />
                    </SankeyNodesCollectionDirective>
                    <SankeyLinksCollectionDirective>
                        <SankeyLinkDirective sourceId="Solar" targetId="Electricity Generation" value={454} />
                        <SankeyLinkDirective sourceId="Nuclear" targetId="Electricity Generation" value={185} />
                        <SankeyLinkDirective sourceId="Wind" targetId="Electricity Generation" value={47.8} />
                        <SankeyLinkDirective sourceId="Geothermal" targetId="Electricity Generation" value={40} />
                        <SankeyLinkDirective sourceId="Natural Gas" targetId="Electricity Generation" value={800} />
                        <SankeyLinkDirective sourceId="Coal" targetId="Electricity Generation" value={28.7} />
                        <SankeyLinkDirective sourceId="Biomass" targetId="Electricity Generation" value={50} />
                        <SankeyLinkDirective sourceId="Electricity Generation" targetId="Residential" value={182} />
                        <SankeyLinkDirective sourceId="Natural Gas" targetId="Residential" value={400} />
                        <SankeyLinkDirective sourceId="Petroleum" targetId="Residential" value={50} />
                        <SankeyLinkDirective sourceId="Electricity Generation" targetId="Commercial" value={351} />
                        <SankeyLinkDirective sourceId="Natural Gas" targetId="Commercial" value={300} />
                        <SankeyLinkDirective sourceId="Electricity Generation" targetId="Industrial" value={641} />
                        <SankeyLinkDirective sourceId="Natural Gas" targetId="Industrial" value={786} />
                        <SankeyLinkDirective sourceId="Biomass" targetId="Industrial" value={563} />
                        <SankeyLinkDirective sourceId="Petroleum" targetId="Industrial" value={300} />
                        <SankeyLinkDirective sourceId="Electricity Generation" targetId="Transportation" value={20} />
                        <SankeyLinkDirective sourceId="Natural Gas" targetId="Transportation" value={51} />
                        <SankeyLinkDirective sourceId="Biomass" targetId="Transportation" value={71} />
                        <SankeyLinkDirective sourceId="Petroleum" targetId="Transportation" value={2486} />
                        <SankeyLinkDirective sourceId="Residential" targetId="Rejected Energy" value={432} />
                        <SankeyLinkDirective sourceId="Commercial" targetId="Rejected Energy" value={351} />
                        <SankeyLinkDirective sourceId="Industrial" targetId="Rejected Energy" value={972} />
                        <SankeyLinkDirective sourceId="Transportation" targetId="Rejected Energy" value={1920} />
                        <SankeyLinkDirective sourceId="Residential" targetId="Energy Services" value={200} />
                        <SankeyLinkDirective sourceId="Commercial" targetId="Energy Services" value={300} />
                        <SankeyLinkDirective sourceId="Industrial" targetId="Energy Services" value={755} />
                        <SankeyLinkDirective sourceId="Transportation" targetId="Energy Services" value={637} />
                    </SankeyLinksCollectionDirective>
                    <Inject services={[SankeyTooltip, SankeyLegend, SankeyExport]} />
                </SankeyComponent>
            </div>
        </div>
    );
}

export default App;
ReactDOM.render(<App />, document.getElementById('sankey'));

Run the Development Server

Now run the npm run dev command in the console to start the development server. This command compiles your code and serves the application locally in your browser at http://localhost:5173 by default.

npm run dev

To stop the development server, press Ctrl+C in the terminal.

Troubleshooting

  • Module not found: Can't resolve '@syncfusion/ej2-react-charts' — Package not installed or wrong working directory. Run npm install @syncfusion/ej2-react-charts inside the project root.
  • Tooltip/legend don’t appear — Modules not injected. Ensure SankeyTooltip and/or SankeyLegend are passed to the Inject service as shown in the “Module injection” step.
  • ERESOLVE peer-dependency errors — Mismatched React version. Install a supported React version (18 or 19) and rerun npm install.

See also

  • Explore the full SankeyChart API reference for all props, events, and methods.

Getting Started with Vue Sankey Chart Component in Vue 2

This article provides a step-by-step guide for setting up a Vue 2 project using Vue-CLI and integrating the Syncfusion® Vue Sankey chart component.

Prerequisites

Ensure your development environment meets the following requirements as listed in System requirements for Syncfusion® Vue UI components

Dependencies

The following list shows the minimum dependencies required to use the Sankey Chart component:


|-- @syncfusion/ej2-vue-charts
    |-- @syncfusion/ej2-base
    |-- @syncfusion/ej2-data
    |-- @syncfusion/ej2-charts
    |-- @syncfusion/ej2-vue-base
    |-- @syncfusion/ej2-pdf-export
    |-- @syncfusion/ej2-file-utils
    |-- @syncfusion/ej2-compression
    |-- @syncfusion/ej2-svg-base

Setting up the Vue 2 project

To generate a Vue 2 project using Vue-CLI, use the vue create command. Follow these steps to install Vue CLI and create a new project:

npm install -g @vue/cli
vue create quickstart

or

yarn global add @vue/cli
vue create quickstart

When creating a new project, choose the option Default ([Vue 2] babel, eslint) from the menu.

Terminal showing Vue CLI creating a Vue 2 project

Once the quickstart project is set up with default settings, navigate to the project directory:

cd quickstart

Now, proceed to add Syncfusion® packages to the project.

Add Syncfusion® Vue packages

Syncfusion® packages are available at npmjs.com. To use Vue components, install the required npm package.

This article uses the Vue Sankey Chart component as an example. Install the @syncfusion/ej2-vue-charts package by running:

npm install @syncfusion/ej2-vue-charts

or

yarn add @syncfusion/ej2-vue-charts

Note: npm v5+ saves packages to dependencies by default; --save is not required.

Add Syncfusion® Vue Component

Follow the steps below to add the Sankey Chart component:

Step 1: Import and register the Sankey Chart component in the script section of the src/App.vue file.

<script>
import {
  SankeyComponent
} from '@syncfusion/ej2-vue-charts';

export default {
  components: {
    'ejs-sankey': SankeyComponent
  }
};
</script>

Step 2: In the template section, define the Sankey Chart component:

<template>
  <div id="app">
    <ejs-sankey id="container"></ejs-sankey>
  </div>
</template>

Here is the summarized code for the above steps in the src/App.vue file:

<template>
  <div class="control-pane">
    <div class="control-section"  id="sankey-container">
      <ejs-sankey
        width="90%"
        height="420px"
        :title="title"
      >
        <e-sankey-nodes-collection>
          <e-sankey-node id="A" />
          <e-sankey-node id="B" />
          <e-sankey-node id="C" />
        </e-sankey-nodes-collection>

        <e-sankey-links-collection>
          <e-sankey-link sourceId="A" targetId="B" :value="100" />
          <e-sankey-link sourceId="B" targetId="C" :value="80" />
        </e-sankey-links-collection>

      </ejs-sankey>
    </div>
  </div>
</template>

<script>
import {
  SankeyComponent,
  SankeyNodesCollectionDirective,
  SankeyNodeDirective,
  SankeyLinksCollectionDirective,
  SankeyLinkDirective,
  SankeyTooltip,
  SankeyLegend,
  SankeyExport
} from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",

  data() {
    return {
      title: "Sankey Chart"
    };
  },

  components: {
    "ejs-sankey": SankeyComponent,
    "e-sankey-nodes-collection": SankeyNodesCollectionDirective,
    "e-sankey-node": SankeyNodeDirective,
    "e-sankey-links-collection": SankeyLinksCollectionDirective,
    "e-sankey-link": SankeyLinkDirective
  },

  provide: {
    sankey: [SankeyTooltip, SankeyLegend, SankeyExport]
  }
};
</script>

<style>
#sankey-container {
  height: 450px;
}
</style>

Run the Project

To run the project, use either npm or Yarn:

npm

npm run serve

yarn

yarn run serve

Open your browser and navigate to http://localhost:8080 to view the Sankey Chart.

Module Registration

The Sankey Chart component is organized into feature-specific modules. In Vue, enable a feature by registering its module(s) in the component’s provide option. The following features are demonstrated in the examples:

  • SankeyLegend — Module for legend support.
  • SankeyTooltip — Module for tooltip support.

The sample code below shows how to register the required modules in the component provide option:

import {
  SankeyComponent,
  SankeyLegend,
  SankeyTooltip
} from '@syncfusion/ej2-vue-charts';

export default {
  components: { 'ejs-sankey': SankeyComponent },
  provide: {
    sankey: [
      SankeyLegend,
      SankeyTooltip,
    ]
  }
};

Populate Sankey Chart with Data

This section explains how to bind JSON data to the Sankey Chart. The data structure requires three properties:

  • source — The starting node name for the link
  • target — The ending node name for the link
  • weight — The value that determines the width of the link

Here is an example data structure:

export default {
  data() {
    return {
      sankeyLinks: [
        { source: 'A', target: 'B', weight: 5 },
        { source: 'A', target: 'C', weight: 3 },
        { source: 'B', target: 'D', weight: 2 },
        { source: 'C', target: 'D', weight: 4 }
      ]
    };
  }
};
<template>
  <div class="control-pane">
    <div class="control-section"  id="sankey-container">
      <ejs-sankey
        width="90%"
        height="420px"
        :title="title"
      >
        <e-sankey-nodes-collection>
          <e-sankey-node id="Energy Input" :label="{ text: 'Energy Input' }" />
          <e-sankey-node id="Generation" :label="{ text: 'Generation' }" />
          <e-sankey-node id="Distribution" :label="{ text: 'Distribution' }" />
          <e-sankey-node id="Consumption" :label="{ text: 'Consumption' }" />
        </e-sankey-nodes-collection>

        <e-sankey-links-collection>
          <e-sankey-link sourceId="Energy Input" targetId="Generation" :value="500" />
          <e-sankey-link sourceId="Generation" targetId="Distribution" :value="450" />
          <e-sankey-link sourceId="Distribution" targetId="Consumption" :value="400" />
        </e-sankey-links-collection>

      </ejs-sankey>
    </div>
  </div>
</template>

<script>
import {
  SankeyComponent,
  SankeyNodesCollectionDirective,
  SankeyNodeDirective,
  SankeyLinksCollectionDirective,
  SankeyLinkDirective
} from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  data() {
    return {
      title: "Energy Flow Diagram"
    };
  },
  components: {
    "ejs-sankey": SankeyComponent,
    "e-sankey-nodes-collection": SankeyNodesCollectionDirective,
    "e-sankey-node": SankeyNodeDirective,
    "e-sankey-links-collection": SankeyLinksCollectionDirective,
    "e-sankey-link": SankeyLinkDirective
  }
};
</script>

<style>
#sankey-container {
  height: 450px;
}
</style>

Troubleshooting

The following are common issues and solutions when integrating the Sankey Chart component:

  • Chart not rendering: Ensure that all required modules (SankeyLegend, SankeyTooltip) are registered in the provide option. Verify that the dataSource property contains valid data with source, target, and weight properties.

  • Module import errors: Confirm that all required modules are imported from @syncfusion/ej2-vue-charts and that the component is registered correctly using the corresponding component-name directive.

  • Data not displaying: Verify that the data structure matches the expected format. Each link object must have source, target, and weight properties. Check the browser console for any data-related errors.

  • Version mismatch: Confirm that the @syncfusion/ej2-vue-charts package version is compatible with Vue 2.6+ used in your project. Install the latest compatible version if needed.

  • Tooltip not showing: If the tooltip feature is enabled but not displaying, verify that SankeyTooltip is registered in the provide option and the tooltip object has enable: true.

Getting Started with Angular Sankey Chart Component

This section explains the steps required to create a simple Angular Sankey Chart and demonstrates the basic usage of the Angular Sankey Chart component.

Note: This guide supports Angular 21 and other recent Angular versions. For detailed compatibility with other Angular versions, please refer to the Angular version support matrix. Starting from Angular 19, standalone components are the default, and this guide reflects that architecture.

Ready to streamline your Syncfusion® Angular development? Discover the full potential of Syncfusion® Angular components with Syncfusion® AI Coding Assistant. Effortlessly integrate, configure, and enhance your projects with intelligent, context-aware code suggestions, streamlined setups, and real-time insights—all seamlessly integrated into your preferred AI-powered IDEs like VS Code, Cursor, Syncfusion® CodeStudio and more. Explore Syncfusion® AI Coding Assistant

Prerequisites

Before getting started, ensure that your environment meets the system requirements for Syncfusion® Angular UI components, which covers supported Node.js, Angular, and @syncfusion/ej2-angular-charts versions.

Setup Angular Environment

A straightforward approach to begin with Angular is to create a new application using the Angular CLI. Install Angular CLI globally with the following command:

npm install -g @angular/cli

Verify the installation:

ng version

Angular 21 Standalone Architecture: Standalone components are the default in Angular 21. This guide uses the modern standalone architecture. If you need more information about the standalone architecture, refer to the Standalone Guide.

Installing a specific version

To install a particular version of Angular CLI, use:

npm install -g @angular/[email protected]

Create an Angular application

With Angular CLI installed, execute the following command to generate a new application:

ng new syncfusion-angular-app
  • This command will prompt you to configure settings like enabling Angular routing and choosing a stylesheet format.
? Which stylesheet format would you like to use? (Use arrow keys)
> CSS             [ https://developer.mozilla.org/docs/Web/CSS]
  Sass (SCSS)     [ https://sass-lang.com/documentation/syntax#scss ]
  Sass (Indented) [ https://sass-lang.com/documentation/syntax#the-indented-syntax ]
  Less            [ http://lesscss.org]
  • By default, a CSS-based application is created. Use SCSS if required:
ng new syncfusion-angular-app --style=scss
  • During project setup, when prompted for the Server-side rendering (SSR) option, choose the appropriate configuration.

SSR

  • Select the required AI tool or ‘none’ if you do not need any AI tool.

AI

Navigate to your newly created application directory:

cd syncfusion-angular-app

Note: In Angular 19 and below, the CLI generates files like app.component.ts, app.component.html, etc. In Angular 20+, the CLI generates a simpler structure with app.ts, app.html, and app.css (no .component. suffixes).

Installing Syncfusion® Sankey Chart Package

Syncfusion®’s Angular component packages are available on npmjs.com. To use the Angular Sankey Chart component, add the Angular Chart package using the Angular CLI:

ng add @syncfusion/ej2-angular-charts

The above command will perform the following configurations:

  • Add the @syncfusion/ej2-angular-charts package and peer dependencies to your package.json.
  • Import the required chart modules into your application automatically.

For more details on version compatibility, refer to the Version Compatibility section.

Ivy library distribution package

Syncfusion®’s latest Angular packages are provided as Ivy-compatible and suited for Angular 12 and above. To install the package, execute:

ng add @syncfusion/ej2-angular-charts

Angular compatibility compiled package (ngcc)

For applications not compiled with Ivy, use the ngcc tagged packages:

npm install @syncfusion/[email protected]

Note: The ngcc packages are still compatible with Angular CLI versions 15 and below. However, they may generate warnings suggesting the use of Ivy compiled packages. Starting from Angular 16, support for the ngcc package has been completely removed. If you have further questions regarding ngcc compatibility, please refer to the following FAQ.

Add the Sankey Chart Component

Update src/app/app.component.ts (or src/app/app.ts in Angular 20+) to render the Sankey Chart component:

import { Component } from '@angular/core';
import { SankeyAllModule } from '@syncfusion/ej2-angular-charts';
import {
  SankeyTooltipService,
  SankeyLegendService,
  SankeyExportService
} from '@syncfusion/ej2-angular-charts';

@Component({
  imports: [SankeyAllModule],
  providers: [
    SankeyTooltipService,
    SankeyLegendService,
    SankeyExportService
  ],
  standalone: true,
  selector: 'app-container',
  template: `
    <div class="control-pane">
      <div class="control-section" id="sankey-container">

        <ejs-sankey
          width="90%"
          height="420px"
          title="Sankey Chart">

          <e-sankey-nodes>
            <e-sankey-node id="A"></e-sankey-node>
            <e-sankey-node id="B"></e-sankey-node>
            <e-sankey-node id="C"></e-sankey-node>
          </e-sankey-nodes>

          <e-sankey-links>
            <e-sankey-link sourceId="A" targetId="B" [value]="100"></e-sankey-link>
            <e-sankey-link sourceId="B" targetId="C" [value]="80"></e-sankey-link>
          </e-sankey-links>

        </ejs-sankey>

      </div>
    </div>
  `
})
export class AppComponent {}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Note: SankeyAllModule registers every available service at once, which is convenient for getting started. For production, prefer the granular SankeyModule (shown later in this guide) and inject only the services you need.

Use the ng serve command to run the application in the browser:

ng serve

Module Injection

Sankey features are segregated into individual feature-wise services. To use a particular feature, you need to inject its corresponding service in app.component.ts.

There are two ways to register Sankey services:

  • SankeyAllModule — Registers every available service at once. Use this for quick setup or when you need most features.
  • SankeyModule — Registers only the services you explicitly add to the providers array. This granular form is recommended for production applications to keep bundle size small.

For this application, the tooltip and legend features of the Sankey Chart are used. The relevant feature service names and descriptions are:

Service Description
SankeyTooltipService Required to render the tooltip.
SankeyLegendService Required to render the legend.

Update src/app/app.component.ts to import the granular SankeyModule and the required services, and add them to the providers array of the component:

import { Component, ViewEncapsulation } from '@angular/core';
import { SankeyModule, SankeyTooltipService, SankeyLegendService } from '@syncfusion/ej2-angular-charts';

@Component({
    imports: [SankeyModule],
    standalone: true,
    selector: 'app-root',
    providers: [SankeyTooltipService, SankeyLegendService],
    template: `<ejs-sankey id="sankey-container"></ejs-sankey>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent { }

The following example uses SankeyModule with the granular providers registered above and renders the empty chart with the tooltip and legend services ready to be used.

// app.component.ts
import { Component } from '@angular/core';
import { SankeyAllModule } from '@syncfusion/ej2-angular-charts';
import {
  SankeyTooltipService,
  SankeyLegendService,
  SankeyExportService
} from '@syncfusion/ej2-angular-charts';
import { Browser } from '@syncfusion/ej2-base';

@Component({
  standalone: true,
  selector: 'app-container',
  imports: [SankeyAllModule],
  providers: [SankeyTooltipService, SankeyLegendService, SankeyExportService],
  template: `
    <div class="control-pane">
      <div class="control-section" id="sankey-container">
        <ejs-sankey
          [width]="'90%'"
          [height]="chartHeight"
          [title]="'California Energy Consumption in 2023'"
          [subTitle]="'Source: Lawrence Livermore National Laboratory'"
          [linkStyle]="linkStyle"
          [labelSettings]="labelSettings"
          [tooltip]="tooltip"
          [legendSettings]="legendSettings"
          (loaded)="onLoaded()"
        >
          <!-- Nodes -->
          <e-sankey-nodes>
            <e-sankey-node id="Electricity Generation" [offset]="-120"></e-sankey-node>
            <e-sankey-node id="Residential" [offset]="38"></e-sankey-node>
            <e-sankey-node id="Commercial" [offset]="36"></e-sankey-node>
            <e-sankey-node id="Industrial" [offset]="34"></e-sankey-node>
            <e-sankey-node id="Transportation" [offset]="32"></e-sankey-node>
            <e-sankey-node id="Rejected Energy" [offset]="-40"></e-sankey-node>
            <e-sankey-node id="Energy Services"></e-sankey-node>
            <e-sankey-node id="Solar"></e-sankey-node>
            <e-sankey-node id="Nuclear"></e-sankey-node>
            <e-sankey-node id="Wind"></e-sankey-node>
            <e-sankey-node id="Geothermal"></e-sankey-node>
            <e-sankey-node id="Natural Gas"></e-sankey-node>
            <e-sankey-node id="Coal"></e-sankey-node>
            <e-sankey-node id="Biomass"></e-sankey-node>
            <e-sankey-node id="Petroleum" [offset]="-10"></e-sankey-node>
          </e-sankey-nodes>

          <!-- Links -->
          <e-sankey-links>
            <e-sankey-link sourceId="Solar" targetId="Electricity Generation" [value]="454"></e-sankey-link>
            <e-sankey-link sourceId="Nuclear" targetId="Electricity Generation" [value]="185"></e-sankey-link>
            <e-sankey-link sourceId="Wind" targetId="Electricity Generation" [value]="47.8"></e-sankey-link>
            <e-sankey-link sourceId="Geothermal" targetId="Electricity Generation" [value]="40"></e-sankey-link>
            <e-sankey-link sourceId="Natural Gas" targetId="Electricity Generation" [value]="800"></e-sankey-link>
            <e-sankey-link sourceId="Coal" targetId="Electricity Generation" [value]="28.7"></e-sankey-link>
            <e-sankey-link sourceId="Biomass" targetId="Electricity Generation" [value]="50"></e-sankey-link>

            <e-sankey-link sourceId="Electricity Generation" targetId="Residential" [value]="182"></e-sankey-link>
            <e-sankey-link sourceId="Natural Gas" targetId="Residential" [value]="400"></e-sankey-link>
            <e-sankey-link sourceId="Petroleum" targetId="Residential" [value]="50"></e-sankey-link>

            <e-sankey-link sourceId="Electricity Generation" targetId="Commercial" [value]="351"></e-sankey-link>
            <e-sankey-link sourceId="Natural Gas" targetId="Commercial" [value]="300"></e-sankey-link>

            <e-sankey-link sourceId="Electricity Generation" targetId="Industrial" [value]="641"></e-sankey-link>
            <e-sankey-link sourceId="Natural Gas" targetId="Industrial" [value]="786"></e-sankey-link>
            <e-sankey-link sourceId="Biomass" targetId="Industrial" [value]="563"></e-sankey-link>
            <e-sankey-link sourceId="Petroleum" targetId="Industrial" [value]="300"></e-sankey-link>

            <e-sankey-link sourceId="Electricity Generation" targetId="Transportation" [value]="20"></e-sankey-link>
            <e-sankey-link sourceId="Natural Gas" targetId="Transportation" [value]="51"></e-sankey-link>
            <e-sankey-link sourceId="Biomass" targetId="Transportation" [value]="71"></e-sankey-link>
            <e-sankey-link sourceId="Petroleum" targetId="Transportation" [value]="2486"></e-sankey-link>

            <e-sankey-link sourceId="Residential" targetId="Rejected Energy" [value]="432"></e-sankey-link>
            <e-sankey-link sourceId="Commercial" targetId="Rejected Energy" [value]="351"></e-sankey-link>
            <e-sankey-link sourceId="Industrial" targetId="Rejected Energy" [value]="972"></e-sankey-link>
            <e-sankey-link sourceId="Transportation" targetId="Rejected Energy" [value]="1920"></e-sankey-link>

            <e-sankey-link sourceId="Residential" targetId="Energy Services" [value]="200"></e-sankey-link>
            <e-sankey-link sourceId="Commercial" targetId="Energy Services" [value]="300"></e-sankey-link>
            <e-sankey-link sourceId="Industrial" targetId="Energy Services" [value]="755"></e-sankey-link>
            <e-sankey-link sourceId="Transportation" targetId="Energy Services" [value]="637"></e-sankey-link>
          </e-sankey-links>
        </ejs-sankey>
      </div>
    </div>
  `
})
export class AppComponent {

  public chartHeight: string = Browser.isDevice ? '600px' : '450px';

  public linkStyle = {
    opacity: 0.6,
    curvature: 0.55,
    colorType: 'Source'
  };

  public labelSettings = {
    visible: !Browser.isDevice
  };

  public tooltip = {
    enable: true
  };

  public legendSettings = {
    visible: true,
    position: 'Bottom',
    itemPadding: 8
  };

  public onLoaded(): void {
    const element = document.getElementById('sankey-container');
    if (element) {
      element.setAttribute('title', '');
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Bind Data to the Sankey Chart

Now that the granular services are registered, you can populate the Sankey Chart with data. Nodes represent the categories, and links represent the flow between them. Each node has a unique id, and each link connects a source node to a target node with a numeric value. The following example shows a simple energy-flow Sankey:

import { Component } from '@angular/core';
import { SankeyAllModule } from '@syncfusion/ej2-angular-charts';
import {
  SankeyTooltipService,
  SankeyLegendService,
  SankeyExportService
} from '@syncfusion/ej2-angular-charts';

@Component({
  imports: [SankeyAllModule],
  providers: [
    SankeyTooltipService,
    SankeyLegendService,
    SankeyExportService
  ],
  standalone: true,
  selector: 'app-container',
  template: `
    <div class="control-pane">
      <div class="control-section" id="sankey-container">

        <ejs-sankey
          width="90%"
          height="420px"
          title="Energy Flow Diagram">

          <e-sankey-nodes>
            <e-sankey-node id="Energy Input" [label]="{ text: 'Energy Input' }"></e-sankey-node>
            <e-sankey-node id="Generation" [label]="{ text: 'Generation' }"></e-sankey-node>
            <e-sankey-node id="Distribution" [label]="{ text: 'Distribution' }"></e-sankey-node>
            <e-sankey-node id="Consumption" [label]="{ text: 'Consumption' }"></e-sankey-node>
          </e-sankey-nodes>

          <e-sankey-links>
            <e-sankey-link sourceId="Energy Input" targetId="Generation" [value]="500"></e-sankey-link>
            <e-sankey-link sourceId="Generation" targetId="Distribution" [value]="450"></e-sankey-link>
            <e-sankey-link sourceId="Distribution" targetId="Consumption" [value]="400"></e-sankey-link>
          </e-sankey-links>

        </ejs-sankey>

      </div>
    </div>
  `
})
export class AppComponent {}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The Sankey diagram renders nodes (rectangles) sized proportionally to their flow, with links (curved bands) connecting source nodes to target nodes. Hovering over a link displays a tooltip with the source, target, and value.

Troubleshooting

If the Sankey Chart does not render as expected, check for these common issues:

  • Chart not visible: Verify that ViewEncapsulation.None is set on the component, that the id on <ejs-sankey> is unique, and that the selector matches the root element in index.html (commonly <app-root>).
  • Data not displayed: Check that your data contains source, target, and value properties and that node ids match exactly between links.
  • Build errors: Run ng version to confirm that Node.js, Angular CLI, and @syncfusion/ej2-angular-charts are on supported versions.

See also